; +++++ Date and Time Picker Example +++++
; ++++++++ Programmed by Luis Costa ++++++
; ++++++++++ xandaz.orgfree.com ++++++++++
; ++++++++++ xandaz@hotmail.com ++++++++++
; +++++++++++ Lisbon, Portugal +++++++++++

.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
AddComma    PROTO   :DWORD
AddString   PROTO   :DWORD,:DWORD
ConvertToDecString  PROTO   :WORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     300
MainWindowHeight    equ     112

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Date & Time Picker Example',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

DateTimeClass   db      'SysDateTimePick32',0
DatePickName    db      'Date And Time',0
hDateTime       dd          ?

StaticClass     db      'STATIC',0
hStatic         dd          ?
rect            RECT        <>
iccx            INITCOMMONCONTROLSEX    <sizeof iccx,ICC_DATE_CLASSES>

DayBuffer   db  3 Dup(0)
YearBuffer  db  5 dup(0)
StringBuffer    db      100 Dup(0)
Months      db  1,'January',0,2,'February',0,3,'March',0,4,'April',0
            db  5,'May',0,6,'June',0,7,'July',0,8,'August',0
            db  9,'September',0,10,'October',0,11,'November',0,12,'December',0
_st     SYSTEMTIME  <2011,01,?,27,?,?,?,?>            
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            invoke  InitCommonControlsEx,addr iccx
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,NULL,addr DateTimeClass,addr DatePickName,WS_VISIBLE+WS_CHILD+DTS_SHOWNONE+\
                                DTS_TIMEFORMAT+DTS_UPDOWN,0,0,rect.right,40,hWnd,NULL,hInstance,NULL                               
            mov hDateTime,eax
            add     rect.top,42
            mov     rect.bottom,32
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_SIMPLE,\
                                0,rect.top,rect.right,32,hWnd,NULL,hInstance,NULL
            mov     hStatic,eax 
            invoke  SendMessage,hDateTime,WM_GETFONT,NULL,NULL
            invoke  SendMessage,hStatic,WM_SETFONT,eax,FALSE                             
                                
        .endif    
    .elseif uMsg==WM_NOTIFY
            mov edi,lParam
            .if [edi.NMDATETIMECHANGE].nmhdr.code==DTN_DATETIMECHANGE
                .if [edi.NMDATETIMECHANGE].dwFlags==GDT_VALID
                     invoke  SendMessage,hDateTime,DTM_GETSYSTEMTIME,GDT_VALID,addr _st
                     lea    edi,_st
                     assume  edi:PTR SYSTEMTIME
                     mov bx,[edi].wDay
                     invoke  ConvertToDecString,bx,addr DayBuffer,2
                     invoke  AddString,addr DayBuffer,addr StringBuffer
                     mov bx,[edi].wMonth
                     lea esi,Months
                     xor    ah,ah
                     cld
     looper:
                     lodsb
                     cmp bx,ax
                     je  month
                     cmp al,12
                     je  skip_month
     realign:
                     lodsb
                     cmp al,0
                     jne realign                
                     jmp looper
     month:          
                     invoke  AddComma,addr StringBuffer
                     invoke  AddString,esi,addr StringBuffer              
     skip_month:                
                     invoke  AddComma,addr StringBuffer
                     mov bx,[edi].wYear
                     invoke  ConvertToDecString,bx,addr YearBuffer,4
                     invoke  AddString,addr YearBuffer,addr StringBuffer
                     invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr StringBuffer
                     lea    edi,StringBuffer
                     mov    byte ptr [edi],0
                .endif     
            .endif                                                    
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

AddComma    PROC    lpBuffer:LPSTR

    push    eax
    push    esi
    push    edi
    pushfd
    mov esi,lpBuffer
    cld
looper:
    lodsb
    cmp al,0
    jne looper
    dec esi
    mov edi,esi
    mov al,','
    mov ah,0
    stosw
    popfd
    pop edi
    pop esi
    pop eax
    ret

AddComma    endp

AddString   PROC    lpString:DWORD,lpBuffer:DWORD

    push    eax
    push    esi
    push    edi
    pushfd
    mov     esi,lpBuffer
    cld
_align:
    lodsb
    cmp al,0
    jne _align
    dec esi
    mov edi,esi
    mov esi,lpString        
looper:
    lodsb
    cmp al,0
    je  end_looper
    stosb
    jmp looper
end_looper:    
    stosb
    popfd
    pop     edi
    pop     esi
    pop     eax
    ret

AddString   endp

ConvertToDecString  PROC    nVal:WORD,lpBuffer:LPSTR,cCount:DWORD

    pushad
    pushfd    
    xor eax,eax
    mov ax,nVal
    mov bx,10
    mov ecx,cCount
    mov edi,lpBuffer
    add edi,cCount
    push    edi
    dec edi
    std
looper:
    xor edx,edx
    div bx    
    push  ax
    push  ebx
    mov al,dl
    add al,30h
    stosb
    pop ebx
    pop ax
    dec ecx
    jcxz    end_looper
    jmp looper
end_looper:
    pop edi
    cld
    mov al,0
    stosb
    popfd
    popad
    ret

ConvertToDecString  endp

        
end start                                            
